# encoding: utf-8

require File.join(File.dirname(__FILE__), 'gnuplot')

def plot(source, configuration)
  options = { :style => "lines", :title => "notitle" }.merge(configuration)

  Gnuplot.open do |gp|
    Gnuplot::Plot.new(gp) do |plot|
      plot.xrange(options[:xrange])
      plot.yrange(options[:yrange]) if options[:yrange]
      plot.terminal("postscript eps")
      plot.output(options[:filename])
      plot.data << Gnuplot::DataSet.new(source) do |ds|
        ds.title = options[:title]
        ds.with = options[:style] == "stem" ? "impulses" : options[:style]
        ds.linewidth = 1
      end
      if ["stem", "fsteps"].include?(options[:style])
        plot.data << Gnuplot::DataSet.new(source) do |ds|
          ds.with = "points"
          ds.pointtype = 6
          ds.title = "notitle"
          ds.linewidth = 1
        end
      end
      plot.data << Gnuplot::DataSet.new("0") do |ds|
        ds.with = "lines"
        ds.linetype = 2
        ds.title = "notitle"
        ds.linewidth = 1
      end
    end
  end
end
